%define _disable_ld_as_needed    1
%define _disable_ld_no_undefined 1
%define _disable_ld_O1           1
#define _disable_ld_build_id     1
#define _disable_ld_relro        1
%define _disable_ld_enable_new_dtags 1

%bcond_with xemacs

# Address randomization breaks gcl's memory management scheme
# -fstack-protector leads to segfaults because GCL uses its own conflicting
# stack protection scheme.
%undefine _ssp_cflags

# GCL wants to read uncompressed info files.  Turn off automatic compression.
%global __brp_compress %{_bindir}/true

# FASL file loads fail with an unexpected EOF error without this.  I do not yet
# know why.
%global __brp_strip_lto %{_bindir}/true

# Use of LTO leads to strange segfaults, reason as yet unknown.
%global _lto_cflags %{nil}

# Upstream prerelease number
%global prerel 95

Name:           gcl
Version:        2.6.13
Release:        %mkrel 0.%{prerel}.4
Summary:        GNU Common Lisp

Group:          Development/Other
License:        GPL+ and LGPLv2+
URL:            http://www.gnu.org/software/gcl/
Source0:        ftp://ftp.gnu.org/pub/gnu/%{name}/%{name}-2.6.12.tar.gz
Source1:        gcl.el
# This is some info files that are needed for the DESCRIBE function to do
# something useful.  These files are present in git HEAD (i.e., the upcoming
# 2.7.0 release), but are missing in the 2.6 branch.
Source2:        %{name}-2.6.8-info.tar.xz

# Upstream builds point releases for Debian, and uploads the patches directly
# to the Debian Patch Tracker, but does not spin new tarballs.  These are the
# upstream patches from https://sources.debian.org/patches/gcl/.
Patch0:         Version_2_6_13pre1.patch
Patch1:         Version_2_6_13pre1a.patch
Patch2:         Version_2_6_13pre1b.patch
Patch3:         Version_2_6_13pre2.patch
Patch4:         Version_2_6_13pre3.patch
Patch5:         Version_2_6_13pre3a.patch
Patch6:         Version_2_6_13pre4.patch
Patch7:         Version_2_6_13pre5.patch
Patch8:         Version_2_6_13pre6.patch
Patch9:         Version_2_6_13pre7.patch
Patch10:        Version_2_6_13pre8a.patch
Patch11:        Version_2_6_13pre8b.patch
Patch12:        Version_2_6_13pre12.patch
Patch13:        Version_2_6_13pre13.patch
Patch14:        Version_2_6_13pre16.patch
Patch15:        Version_2_6_13pre17.patch
Patch16:        Version_2_6_13pre18.patch
Patch17:        Version_2_6_13pre19.patch
Patch18:        Version_2_6_13pre20.patch
Patch19:        Version_2_6_13pre22.patch
Patch20:        Version_2_6_13pre25.patch
Patch21:        Version_2_6_13pre26.patch
Patch22:        Version_2_6_13pre27.patch
Patch23:        Version_2_6_13pre28.patch
Patch24:        Version_2_6_13pre29.patch
Patch25:        Version_2_6_13pre30.patch
Patch26:        Version_2_6_13pre31.patch
Patch27:        Version_2_6_13pre32.patch
Patch28:        Version_2_6_13pre33.patch
Patch29:        Version_2_6_13pre34.patch
Patch30:        Version_2_6_13pre35.patch
Patch31:        Version_2_6_13pre36.patch
Patch32:        Version_2_6_13pre38.patch
Patch33:        Version_2_6_13pre39.patch
Patch34:        data_bss_offset-in-unexec-sparc64-fix.patch
Patch35:        Version_2_6_13pre41.patch
Patch36:        Version_2_6_13pre45.patch
Patch37:        Version_2_6_13pre46.patch
Patch38:        Version_2_6_13pre47.patch
Patch39:        Version_2_6_13pre48.patch
Patch40:        Version_2_6_13pre49.patch
Patch41:        Version_2_6_13pre50.patch
Patch42:        pathnames1.1.patch
Patch43:        ansi-test-clean-target.patch
Patch44:        pathnames1.2.patch
Patch45:        pathnames1.3.patch
Patch46:        pathnames1.4.patch
Patch47:        pathnames1.5.patch
Patch48:        pathnames1.6.patch
Patch49:        pathnames1.7.patch
Patch50:        pathnames1.9.patch
Patch51:        pathnames1.11.patch
Patch52:        pathnames1.12.patch
Patch53:        pathnames1.13.patch
Patch54:        list_order.1.patch
Patch55:        list_order.5.patch
Patch56:        list_order.6.patch
Patch57:        defined_real_maxpage.patch
Patch58:        list_order.7.patch
Patch59:        list_order.8.patch
Patch60:        list_order.9.patch
Patch61:        list_order.11.patch
Patch62:        disable_gprof_aarch64.patch
Patch63:        list_order.12.patch
Patch64:        real_list_order.12.patch
Patch65:        list_order.13.patch
Patch66:        list_order.4.patch
Patch67:        list_order.16.patch
Patch68:        list_order.17.patch
Patch69:        list_order.18.patch
Patch70:        list_order.19.patch
Patch71:        list_order.20.patch
Patch72:        list_order.21.patch
Patch73:        list_order.22.patch
Patch74:        list_order.23.patch
Patch75:        list_order.24.patch
Patch76:        list_order.25.patch
Patch77:        Version_2_6_13pre52.patch
Patch78:        Version_2_6_13pre54.patch
Patch79:        Version_2_6_13pre55.patch
Patch80:        Version_2_6_13pre56.patch
Patch81:        Version_2_6_13pre57.patch
Patch82:        Version_2_6_13pre58.patch
Patch83:        Version_2_6_13pre59.patch
Patch84:        Version_2_6_13pre60.patch
Patch85:        Version_2_6_13pre61.patch
Patch86:        Version_2_6_13pre62.patch
Patch87:        Version_2_6_13pre63.patch
Patch88:        Version_2_6_13pre64.patch
Patch89:        Version_2_6_13pre65.patch
Patch90:        Version_2_6_13pre66.patch
Patch91:        Version_2_6_13pre67.patch
Patch92:        Version_2_6_13pre68.patch
Patch93:        Version_2_6_13pre69.patch
Patch94:        Version_2_6_13pre70.patch
Patch95:        Version_2_6_13pre71.patch
Patch96:        Version_2_6_13pre72.patch
Patch97:        Version_2_6_13pre73.patch
Patch98:        Version_2_6_13pre74.patch
Patch99:        Version_2_6_13pre76.patch
Patch100:       Version_2_6_13pre77.patch
Patch101:       Version_2_6_13pre78.patch
Patch102:       Version_2_6_13pre79.patch
Patch103:       Version_2_6_13pre80.patch
Patch104:       Version_2_6_13pre81.patch
Patch105:       Version_2_6_13pre82.patch
Patch106:       Version_2_6_13pre83.patch
Patch107:       Version_2_6_13pre84.patch
Patch108:       Version_2_6_13pre85.patch
Patch109:       Version_2_6_13pre86.patch
Patch110:       Version_2_6_13pre87.patch
Patch111:       Version_2_6_13pre88.patch
Patch112:       Version_2_6_13pre89.patch
Patch113:       Version_2_6_13pre90.patch
Patch114:       Version_2_6_13pre92.patch
Patch115:       Version_2_6_13pre94.patch
Patch116:       Version_2_6_13pre95.patch
Patch117:       Version_2.6.13pre96.patch

### Fedora patches
# This patch was last sent upstream on 29 Dec 2008.  It fixes a file descriptor
# leak, as well as combining 4 system calls into only 2 on an exec().
Patch500:       %{name}-2.6.12-fd-leak.patch
# This patch was last sent upstream on 29 Dec 2008.  It updates one source file
# from LaTeX 2.09 to LaTeX 2e, thereby eliminating LaTeX warnings about running
# in compatibility mode.
Patch501:       %{name}-2.6.11-latex.patch
# This patch was last sent upstream on 29 Dec 2008.  It adapts to texinfo 5.0.
Patch502:       %{name}-2.6.11-texinfo.patch
# This patch was last sent upstream on 29 Dec 2008.  It fixes a large number of
# compile- and run-time problems with the Emacs interface code.
Patch503:       %{name}-2.6.11-elisp.patch
# This is a Fedora-specific patch.  Do not delete C files produced from D files
# so they can be pulled into the debuginfo package.
Patch504:       %{name}-2.6.11-debuginfo.patch
# This patch was last sent upstream on 13 Oct 2009.  It fixes two bugs in the
# reading of PLT information.
Patch505:       %{name}-2.6.11-plt.patch
# This patch was last sent upstream on 13 Oct 2009.  It fixes several malformed
# function prototypes involving an ellipsis.
Patch506:       %{name}-2.6.11-ellipsis.patch
# Fix a linker problem on ARM platforms.
Patch507:       %{name}-2.6.11-arm.patch
# This patch was last sent upstream on 29 Dec 2008.  It updates the autoconf
# and libtool files to newer versions.  By itself, this patch accomplishes
# little of interest.  However, some of the later patches change configure.in.
# Without this patch, autoconf appears to run successfully, but generates a
# configure script that contains invalid shell script syntax.
Patch508:       %{name}-2.6.11-infrastructure.patch
# This patch was last sent upstream on 29 Dec 2008.  It rationalizes the
# handling of system extensions.  For example, on glibc-based systems, some
# functionality is available only when _GNU_SOURCE is defined.
Patch509:       %{name}-2.6.11-extension.patch
# This patch was last sent upstream on 29 Dec 2008.  It fixes a compilation
# error on newer GCC systems due to an include inside a function.  This affects
# the "unrandomize" sbrk() functionality, hence the name of the patch.
Patch510:       %{name}-2.6.12-unrandomize.patch
# The need for this patch was last communicated to upstream on 21 May 2009.
# Without this patch, compilation fails due to conflicting type definitions
# between glibc and Linux kernel headers.  This patch prevents the kernel
# headers from being used.
Patch511:       %{name}-2.6.11-asm-signal-h.patch
# Turn address randomization off early.  GCL is linked with libtirpc, which is
# linked with libselinux, which has a static initializer that calls malloc()
# and free() on systems that do not have /sys/fs/selinux or /selinux mounted,
# or have them mounted read-only.
# (tv) disabled: we don't enable selinux
#Patch512:       %{name}-2.6.12-libselinux.patch

BuildRequires:  binutils-devel
BuildRequires:  bzip2
BuildRequires:  gcc
BuildRequires:  gmp-devel
BuildRequires:  make
BuildRequires:  pkgconfig(libtirpc)
BuildRequires:  pkgconfig(readline)
BuildRequires:  pkgconfig(sm)
BuildRequires:  pkgconfig(tcl)
BuildRequires:  pkgconfig(tk)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xaw7)
BuildRequires:  texlive
BuildRequires:  texlive-texmf
BuildRequires:  texinfo
BuildRequires:  emacs-bin
BuildRequires:  emacs-el
%if %{with xemacs}
BuildRequires:  xemacs
BuildRequires:  xemacs-devel
%endif
BuildRequires:  x11-server-common

%description
GCL is a Common Lisp currently compliant with the ANSI standard.  Lisp
compilation produces native code through the intermediary of the
system's C compiler, from which GCL derives efficient performance and
facile portability. Currently uses TCL/Tk as GUI.


%package        emacs
Group:          Development/Other
Summary:        Emacs mode for interacting with GCL
Requires:       %{name} = %{version}-%{release}
Requires:       emacs >= %{_emacs_version}
BuildArch:      noarch

%description    emacs
Emacs mode for interacting with GCL.

%if %{with xemacs}
%package xemacs
Summary:        XEmacs mode for interacting with GCL
Requires:       %{name} = %{version}-%{release}
Requires:       xemacs(bin) >= %{_xemacs_version}, xemacs-packages-extra
BuildArch:      noarch

%description xemacs
XEmacs mode for interacting with GCL
%endif



%prep
%autosetup -n %{name} -a 2 -p1

# Don't insert line numbers into cmpinclude.h; the compiler gets confused
sed -i 's,\($(CC) -E\) -I,\1 -P -I,' makefile

# The binary MUST be run with address randomization off.  The main() function
# has code to accomplish that, but it does not run early enough.  Ensure that
# randomization is off before GCL even starts.
# (tv) disabled: we don't enable selinux
#sed -i 's,echo exec,& %{_bindir}/setarch -R,' makefile

# Ensure the frame pointer doesn't get added back
sed -i 's/"-fomit-frame-pointer"/""/' configure

# Fix a path in the launch script
sed -i 's|/usr/lib/tk|%{_datadir}/tk|' debian/gcl.sh

# Get a version of texinfo.tex that works with the installed version of texinfo
cp -p %{_datadir}/texmf-dist/tex/texinfo/texinfo.tex info

# The archive is so full of spurious executable bits that we just remove them
# all here, then add back the ones that should exist
find . -type f -perm /0111 | xargs chmod a-x
chmod a+x add-defs add-defs1 config.guess config.sub configure install.sh
chmod a+x bin/info bin/info1 gcl-tk/gcltksrv.in gcl-tk/ngcltksrv mp/gcclab 
chmod a+x o/egrep-def utils/replace xbin/*

%build
# SGC requires the frame pointer
export CFLAGS="%{optflags} -fno-omit-frame-pointer -fwrapv"
%configure --enable-readline --enable-ansi --enable-dynsysgmp --enable-xgcl \
  --enable-tclconfig=%{_libdir} --enable-tkconfig=%{_libdir}

# FIXME: %%{?_smp_mflags} breaks the build
make

# Build gcl.info, which is needed for DESCRIBE to work properly
make -C info gcl.info

# dwdoc needs one extra LaTeX run to resolve references
cd xgcl-2
pdflatex dwdoc.tex

%install
%make_install

# Get rid of the parts that we don't want
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
rm -rf $RPM_BUILD_ROOT%{_datadir}/doc
rm -rf $RPM_BUILD_ROOT%{_datadir}/emacs
rm -rf $RPM_BUILD_ROOT%{_prefix}/lib/gcl-*/info

# Install the man page
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
cp -pf man/man1/* $RPM_BUILD_ROOT%{_mandir}/man1

# Install the HTML documentation
mkdir -p html
cp -pfr info/gcl-si info/gcl-tk html

# Install and compile the Emacs code
mkdir -p $RPM_BUILD_ROOT%{_emacs_sitelispdir}/gcl
cp -pfr elisp/* $RPM_BUILD_ROOT%{_emacs_sitelispdir}/gcl
rm -f $RPM_BUILD_ROOT%{_emacs_sitelispdir}/gcl/makefile
rm -f $RPM_BUILD_ROOT%{_emacs_sitelispdir}/gcl/readme
mkdir -p $RPM_BUILD_ROOT%{_emacs_sitestartdir}
sed -e "s|%LISP_DIR%|%{_emacs_sitelispdir}|" %{SOURCE1} > $RPM_BUILD_ROOT%{_emacs_sitestartdir}/gcl.el
pushd $RPM_BUILD_ROOT%{_emacs_sitelispdir}/gcl
%{_emacs_bytecompile} *.el
popd

%if %{with xemacs}
# Install and compile the XEmacs code
mkdir -p $RPM_BUILD_ROOT%{_xemacs_sitelispdir}/gcl
cp -fr elisp/* $RPM_BUILD_ROOT%{_xemacs_sitelispdir}/gcl
rm -f $RPM_BUILD_ROOT%{_xemacs_sitelispdir}/gcl/makefile
rm -f $RPM_BUILD_ROOT%{_xemacs_sitelispdir}/gcl/readme
mkdir -p $RPM_BUILD_ROOT%{_xemacs_sitestartdir}
sed -e "s|%LISP_DIR%|%{_xemacs_sitelispdir}|" %{SOURCE1} > $RPM_BUILD_ROOT%{_xemacs_sitestartdir}/gcl.el
pushd $RPM_BUILD_ROOT%{_xemacs_sitelispdir}/gcl
%{_xemacs_bytecompile} *.el
popd
%endif

# The image has garbage strings containing RPM_BUILD_ROOT
export QA_SKIP_BUILD_ROOT=1


%files
%{_bindir}/gcl
%{_prefix}/lib/gcl*
%{_infodir}/*
%{_mandir}/man*/*
%doc readme readme.xgcl RELEASE* ChangeLog* faq doc
%doc gcl*.jpg gcl.ico gcl.png
%doc html/gcl-si html/gcl-tk
%license COPYING*

%files emacs
%doc elisp/readme
%{_emacs_sitelispdir}/gcl/
%{_emacs_sitestartdir}/*

%if %{with xemacs}
%files xemacs
%doc elisp/readme
%{_xemacs_sitelispdir}/gcl/
%{_xemacs_sitestartdir}/*
%endif


%changelog
* Thu Jan 07 2021 tv <tv> 2.6.13-0.95.4.mga8
+ Revision: 1669439
- Update to 2.6.13pre95
- disable selinux patch as we don't have it
- try harder to pass on aarch64
- no more need to set -fcommon, it's set by upstream
- drop old obsoletes tag
- fix mismerge in description
- use %%license
- Update to 2.6.13pre93
+ joequant <joequant>
- fix aarch64 build
- fix gcc10 build
- fix gcc10 build
+ ovitters <ovitters>
- remove install-info scriptlets, rely on filetrigger instead (mga#27107)
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sat Jan 04 2020 luigiwalser <luigiwalser> 2.6.12-8.mga8
+ Revision: 1475947
- rebuild for readline

* Sun Oct 14 2018 wally <wally> 2.6.12-7.mga7
+ Revision: 1320259
- sync patches and also a bit of .spec with Fedora
+ umeabot <umeabot>
- Mageia 7 Mass Rebuild
+ kekepower <kekepower>
- Use make_install

* Sun Jan 21 2018 wally <wally> 2.6.12-5.mga7
+ Revision: 1195563
- add patches from Fedora and Debian to fix build issues in other pkgs like maxima

* Tue Jan 02 2018 wally <wally> 2.6.12-4.mga7
+ Revision: 1189430
- rebuild for new readline

* Fri Feb 12 2016 marja <marja> 2.6.12-3.mga6
+ Revision: 959176
- Start to obsolete cgcl-xemacs and gcl-xemacs-el < 2.6.12-3

* Fri Nov 27 2015 pterjan <pterjan> 2.6.12-2.mga6
+ Revision: 906409
- Do not use libbfd, the code for it is in a really broken state
- Build with gnu89 semantics to fix most problems
+ tv <tv>
- build fix from FC
- new snapshot
+ daviddavid <daviddavid>
- apply patch100 to fix build with tcl 8.6
- do not apply patch18 as it is for tcl 8.5
- rebuild for new tcl/tk 8.6.4

* Wed Oct 15 2014 umeabot <umeabot> 2.6.8.20130823-5.mga5
+ Revision: 742900
- Second Mageia 5 Mass Rebuild

* Mon Oct 13 2014 umeabot <umeabot> 2.6.8.20130823-4.mga5
+ Revision: 738482
- Mageia 5 Mass Rebuild

* Mon Jan 06 2014 danf <danf> 2.6.8.20130823-3.mga4
+ Revision: 565026
- Remove -fPIC from CFLAGS as it is incompatible with gcl
+ umeabot <umeabot>
- Mageia 4 Mass Rebuild
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild
+ luigiwalser <luigiwalser>
- BR texlive-texmf
+ fwang <fwang>
- omi-frame-pointer make it SGC
- 2.6.8 final
+ kamil <kamil>
- sync sources with Fedora
- rebuild for Mga3 Beta1

* Mon Mar 05 2012 kamil <kamil> 2.6.8.20120109cvs-2.mga2
+ Revision: 218547
- rebuild against new gcc-4.6.3

* Mon Feb 06 2012 kamil <kamil> 2.6.8.20120109cvs-1.mga2
+ Revision: 205242
- sync source and patches with Fedora (20120109svn)
- build against emacs 23.3
- build against xemacs 21.4.22

* Wed Jul 06 2011 fwang <fwang> 2.6.8.20101115cvs-4.mga2
+ Revision: 119210
- rebuild for new tcl

* Wed May 11 2011 pterjan <pterjan> 2.6.8.20101115cvs-3.mga1
+ Revision: 97333
- Don't require a version of xemacs that we don't have yet

* Fri Apr 29 2011 dmorgan <dmorgan> 2.6.8.20101115cvs-2.mga1
+ Revision: 93455
- Minor layout change

* Thu Apr 14 2011 tv <tv> 2.6.8.20101115cvs-1.mga1
+ Revision: 85467
- fix texlive BR
- imported package gcl

